%define anolis_release 2
%define abidir %{_prefix}/lib/compatibility/%{name}
Name:           zlib
Version:        1.2.12
Release:        %{anolis_release}%{?dist}
Summary:        Compression and decompression library

License:        zlib and Boost
URL:            https://www.zlib.net/
Source0:        https://zlib.net/zlib-%{version}.tar.xz
# patches from upstream
Patch1:         0001-Fix-configure-issue-that-discarded-provided-CC-defin.patch
Patch2:         0002-Correct-incorrect-inputs-provided-to-the-CRC-functio.patch
# CVE-2022-37434
Patch3:         0003-Fix-a-bug-when-getting-a-gzip-header-extra-field-wit.patch
Patch4:         0004-Fix-extra-field-processing-bug-that-dereferences-NUL.patch

BuildRequires:  make automake autoconf libtool 
BuildRequires: abi-dumper

%description
Zlib is a general-purpose, patent-free, lossless data compression
library which is used by many different programs.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package devel
Summary: Header files and libraries for Zlib development
Requires: %{name} = %{version}-%{release}
 
%description devel
The zlib-devel package contains the header files and libraries needed
to develop programs that use the zlib compression and decompression
library.
 
%package static
Summary: Static libraries for Zlib development
Requires: %{name}-devel = %{version}-%{release}
 
%description static
The zlib-static package includes static libraries needed
to develop programs that use the zlib compression and
decompression library.
 
%package -n minizip-compat
Summary: Library for manipulation with .zip archives
Requires: %{name} = %{version}-%{release}
 
%description -n minizip-compat
Minizip is a library for manipulation with files from .zip archives.
 
%package -n minizip-compat-devel
Summary: Development files for the minizip library
Requires: minizip-compat = %{version}-%{release}
Requires: %{name}-devel = %{version}-%{release}
Conflicts: minizip-devel
 
%description -n minizip-compat-devel
This package contains the libraries and header files needed for
developing applications which use minizip.

%prep
%autosetup -p1

%build
export CFLAGS="$RPM_OPT_FLAGS"
export LDFLAGS="$LDFLAGS -Wl,-z,relro -Wl,-z,now"
./configure --libdir=%{_libdir} --includedir=%{_includedir} --prefix=%{_prefix}

%make_build

cd contrib/minizip
autoreconf --install
%configure --enable-static=no
%make_build

%check
make test

%install
%make_install

%make_install -C contrib/minizip

find $RPM_BUILD_ROOT -name '*.la' -delete

mkdir -p %{buildroot}/%{abidir}
pushd %{buildroot}/%{abidir}
for full_name in $(find %{buildroot} -name "*.so*") ; do
        f=`echo ${full_name##*/}`
        (file $full_name | grep "shared object" > /dev/null 2>&1 && abi-dumper $full_name -o $f.dump > /dev/null 2>&1) || echo "ok"
done
popd

%files
%license README
%dir %{abidir}
%{_libdir}/libz.so.*
%{abidir}/libz.so.*.dump

%files doc
%doc ChangeLog FAQ

%files devel
%doc doc/algorithm.txt test/example.c
%{_libdir}/libz.so
%{_libdir}/pkgconfig/zlib.pc
%{_includedir}/zlib.h
%{_includedir}/zconf.h
%{_mandir}/man3/zlib.3*
 
%files static
%license README
%{_libdir}/libz.a
 
%files -n minizip-compat
%doc contrib/minizip/MiniZip64_info.txt contrib/minizip/MiniZip64_Changes.txt
%{_libdir}/libminizip.so.*
%{abidir}/libminizip.so.*.dump

%files -n minizip-compat-devel
%dir %{_includedir}/minizip
%{_includedir}/minizip/*.h
%{_libdir}/libminizip.so
%{_libdir}/pkgconfig/minizip.pc


%changelog
* Wed Oct 12 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.2.12-2
- add abi & add doc package

* Tue Aug 30 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.2.12-1
- update to 1.2.12

* Mon Mar  7 2022 forrest_ly <flin@linux.alibaba.com> - 1.2.11-1 
- Init Anolis OS 23 
